FILESEXTRAPATHS:prepend := "${THISDIR}/${PN}:"

SRC_URI += "file://wayland_display.sh"

do_install:append() {
    install -Dm0755 ${WORKDIR}/wayland_display.sh ${D}${sysconfdir}/profile.d/wayland_display.sh

    # Disable blanking the screen on idle
    sed -i -e '/^\[core\]/a idle-time=0' ${D}${sysconfdir}/xdg/weston/weston.ini
}

FILES:${PN} += "\
    ${sysconfdir}/profile.d/wayland_display.sh \
"

# When using imx-gpu-viv to 6.4.11.p1.2 the option changed to boolean
# Applies only to i.MX8 as i.MX6 uses different driver,
# thus requiring 'use-g2d=1'
INI_UNCOMMENT_USE_G2D:mx8-nxp-bsp:imxgpu2d = "use-g2d=true"

update_file() {
    if ! grep -q "$1" $3; then
        bbfatal $1 not found in $3
    fi
    sed -i -e "s,$1,$2," $3
}

do_install:append:mx95-nxp-bsp() {
    if ${@bb.utils.contains('DISTRO_FEATURES','systemd','true','false',d)}; then
        # FIXME: weston should be run as weston, not as root
        update_file "User=weston" "User=root" ${D}${systemd_system_unitdir}/weston.service
        update_file "Group=weston" "Group=root" ${D}${systemd_system_unitdir}/weston.service
    fi
}
