# Common definitions for TQ-Systems GmbH MBa93xxCA / MBa93xxLA

# Machine specific options

WKS_FILE = "tqmaxx-imx-v8-sdimg.wks.in"

MACHINE_FEATURES += "\
    bluetooth \
    screen \
    touchscreen \
    usbhost \
    wifi \
"

# we have no audio interface on our board.
MACHINE_FEATURES:remove = "alsa"

# direct assign to SERIAL_CONSOLES to prevent wrong defaults and not using
# deprecated SERIAL_CONSOLE
SERIAL_CONSOLES = "115200;ttyLP0"

# disable virtual console support for this board and limit getty to SERIAL_CONSOLES only
USE_VT = "0"

# recipe imx-atf-tq: boot / debug UART.
# Settings for UART1 (default on MBa93xx[CA/LA])
ATF_IMX_BOOT_UART_BASE ?= "0x44380000"

IMXBOOT_TARGETS ?= "\
    flash_singleboot \
    flash_singleboot_flexspi \
"

#
# bootstream name, construction see imx-boot-tq recipe, do_deploy()
#
MACHINE_WKS_BOOTSTREAM ?= "imx-boot-${MACHINE}-sd.bin-flash_singleboot"

MACHINE_EXTRA_RRECOMMENDS += "\
    linux-firmware-pcie8997 \
    linux-firmware-sd8997 \
    linux-firmware-usb8997 \
"
