# Common definitions for TQ-Systems GmbH MBa8MPxL baseboard for TQMa8MPxL modules

require conf/machine/include/tqma8mpxl.inc
require conf/machine/include/mba8-common.inc

# Set u-boot DTB
UBOOT_DTB_NAME = "imx8mp-tqma8mpql-mba8mpxl.dtb"

KERNEL_DEVICETREE = "\
    freescale/imx8mp-tqma8mpql-mba8mpxl.dtb \
"

KERNEL_DEVICETREE_linux-imx-tq = "\
    freescale/imx8mp-tqma8mpql-mba8mpxl-imx327.dtb \
    freescale/imx8mp-tqma8mpql-mba8mpxl-ov9281.dtb \
    freescale/imx8mp-tqma8mpql-mba8mpxl-lvds-g133han01.dtb \
    freescale/imx8mp-tqma8mpql-mba8mpxl-lvds-tm070jvhg33.dtb \
    freescale/imx8mp-tqma8mpql-mba8mpxl-rpmsg.dtb \
"

KERNEL_DEVICETREE_linux-imx-tq:append:mx8mp-nxp-bsp = "\
    ${@bb.utils.contains('MACHINE_FEATURES', 'basler', \
        ' freescale/imx8mp-tqma8mpql-mba8mpxl-lvds-basler.dtb', '', d)} \
"

KERNEL_DEVICETREE += "${@kernel_provider_dtbs(d)}"

MACHINE_FEATURES += "\
    bluetooth \
    camera \
    screen \
    touchscreen \
    wifi \
"

MACHINE_EXTRA_RRECOMMENDS += "${@bb.utils.contains('COMBINED_FEATURES', 'wifi', 'linux-firmware-ath10k', '', d)}"
MACHINE_EXTRA_RRECOMMENDS += "${@bb.utils.contains('COMBINED_FEATURES', 'bluetooth', 'linux-firmware-qca', '', d)}"

# Add packages we want to be deployed, even when they are not part of rootfs
# We need these here to support UBI / NFS boot case
EXTRA_IMAGEDEPENDS += "\
    virtual/imx-cortexm-demos \
"

# Set Serial console @ UART4
SERIAL_CONSOLES = "115200;ttymxc3"
# recipe imx-atf-tq: boot / debug UART address for UART4
ATF_IMX_BOOT_UART_BASE ?= "0x30a60000"

# disable virtual console support for this board and limit getty to SERIAL_CONSOLES only
USE_VT = "0"

CORTEXM_DEMOS += "\
    hello_world.bin \
    rpmsg_lite_pingpong_rtos_linux_remote.bin \
"

IMAGE_BOOT_FILES = "\
    ${@create_image_boot_dtb_files(d)} \
    ${CORTEXM_DEMOS} \
    ${KERNEL_IMAGETYPE} \
"

# SD boot image and FlexSPI boot image can be built using same U-Boot config
IMXBOOT_TARGETS ?= "\
    flash_evk_flexspi \
    flash_spl_uboot \
"

#
# bootstream name, construction see imx-boot recipe, do_deploy
#
MACHINE_WKS_BOOTSTREAM ?= "imx-boot-${MACHINE}-sd.bin-flash_spl_uboot"

require tq-distroboot.inc
